#include "stm8L15x.h"
#include "stm8L15x_clk.h"
#include "stm8L15x_gpio.h"
#include "stm8l15x_tim2.h"
#include "stm8l15x_tim3.h"
#include "stm8l15x_flash.h"
#include "stm8l15x_adc.h"
#include "stm8l15x_dma.h"
#include "stm8l15x_syscfg.h"

#define ADC1_DR_ADDRESS        ((uint16_t)0x5344)
#define BUFFER_SIZE            ((uint8_t) 0x02)
#define BUFFER_ADDRESS         ((uint16_t)(&Buffer))
//#define ASCII_NUM_0            ((uint8_t)   48)
uint16_t Buffer[BUFFER_SIZE]  = {0, 0};

uint16_t ADCData = 0;
static void CLK_Config(void)
{
  /* Select HSE as system clock source */
  //CLK_SYSCLKSourceSwitchCmd(ENABLE);
  //CLK_SYSCLKSourceConfig(CLK_SYSCLKSource_HSE);
  /*High speed external clock prescaler: 1*/
  //CLK_SYSCLKDivConfig(CLK_SYSCLKDiv_1);

  //while (CLK_GetSYSCLKSource() != CLK_SYSCLKSource_HSE)
  //{}

  /* Enable ADC1 clock */
  CLK_PeripheralClockConfig(CLK_Peripheral_ADC1, ENABLE);

  /* Enable DMA1 clock */
  //CLK_PeripheralClockConfig(CLK_Peripheral_DMA1, ENABLE);

  /* Enable TIM1 clock */
  CLK_PeripheralClockConfig(CLK_Peripheral_TIM2, ENABLE);
}
//////////////////////////////////////////////////////////////////////////////////
static void ADC_Config(void)
{
  ADC_ScanModeCmd(ENABLE);
   ADC_DataBufferCmd(ENABLE);
   ADC_ITConfig(ADC_IT_EOCIE, ENABLE);
   ADC_ClearITPendingBit(ADC_IT_EOC);
   
   
  /* Initialize and configure ADC1 */
  ADC_Init(ADC1, ADC_ConversionMode_Single, ADC_Resolution_12Bit, ADC_Prescaler_2);
  ADC_SamplingTimeConfig(ADC1, ADC_Group_SlowChannels, ADC_SamplingTime_384Cycles);
  ADC_SamplingTimeConfig(ADC1, ADC_Group_FastChannels, ADC_SamplingTime_384Cycles);

  /* Enable ADC1 */
  ADC_Cmd(ADC1, ENABLE);

  /* Enable ADC1 Channels 3 */
  ADC_ChannelCmd(ADC1, ADC_Channel_3, ENABLE); /* connected to Potentiometer RV */
  /* Enable ADC1 Channels 24 */
  ADC_ChannelCmd(ADC1, ADC_Channel_24, ENABLE); /* connected to BNC */
  //void ADC_ITConfig(ADC1,EOC);
  
}
///////////////////////////////////////////////////////////////////////////////////////
int main()
{
CLK_Config();
ADC_Config();
ADC_DMACmd(ADC1, ENABLE);
ADC_ExternalTrigConfig(ADC1, ADC_ExtEventSelection_Trigger3,ADC_ExtTRGSensitivity_Rising);
TIM2_SelectOutputTrigger(TIM2_TRGOSource_Update);
TIM2_Cmd(ENABLE);

 SYSCFG_REMAPDMAChannelConfig(REMAP_DMA1Channel_ADC1ToChannel0);

  DMA_Init(DMA1_Channel0, BUFFER_ADDRESS,
           ADC1_DR_ADDRESS,
           BUFFER_SIZE,
           DMA_DIR_PeripheralToMemory,
           DMA_Mode_Circular,
           DMA_MemoryIncMode_Inc,
           DMA_Priority_High,
           DMA_MemoryDataSize_HalfWord);

  /* DMA Channel0 enable */
  DMA_Cmd(DMA1_Channel0, ENABLE);

  /* Enable DMA1 channel0 Transfer complete interrupt */
  DMA_ITConfig(DMA1_Channel0, DMA_ITx_TC, ENABLE);

  /* DMA enable */
  DMA_GlobalCmd(ENABLE);
  while(1)
  {
    ADCData = ADC_GetConversionValue(ADC1);
  }
}
